/* $Id: UIWizardNewVDPageVariant.h 88598 2021-04-20 08:16:05Z vboxsync $ */
/** @file
 * VBox Qt GUI - UIWizardNewVDPageVariant class declaration.
 */

/*
 * Copyright (C) 2006-2020 Oracle Corporation
 *
 * This file is part of VirtualBox Open Source Edition (OSE), as
 * available from http://www.virtualbox.org. This file is free software;
 * you can redistribute it and/or modify it under the terms of the GNU
 * General Public License (GPL) as published by the Free Software
 * Foundation, in version 2 as it comes in the "COPYING" file of the
 * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 */

#ifndef FEQT_INCLUDED_SRC_wizards_newvd_UIWizardNewVDPageVariant_h
#define FEQT_INCLUDED_SRC_wizards_newvd_UIWizardNewVDPageVariant_h
#ifndef RT_WITHOUT_PRAGMA_ONCE
# pragma once
#endif

/* GUI includes: */
#include "UIWizardPage.h"

/* Forward declarations: */
class CMediumFormat;
class QButtonGroup;
class QCheckBox;
class QIRichTextLabel;


/* 2nd page of the New Virtual Hard Drive wizard (base part): */
class SHARED_LIBRARY_STUFF UIWizardNewVDPageBaseVariant : public UIWizardPageBase
{
protected:

    /** Constructor: */
    UIWizardNewVDPageBaseVariant();

    QWidget *createMediumVariantWidgets(bool fWithLabels);
    qulonglong mediumVariant() const;
    void setMediumVariant(qulonglong uMediumVariant);
    void retranslateWidgets();
    /** Check Medium format capability and decide if certain widgets can be shown. */
    void setWidgetVisibility(CMediumFormat &mediumFormat);
    void updateMediumVariantWidgetsAfterFormatChange(const CMediumFormat &mediumFormat);
    /** @name Widgets
     * @{ */
        QCheckBox *m_pFixedCheckBox;
        QCheckBox *m_pSplitBox;
    /** @} */

    /** @name Rich text labels. Declared/defined here since the are shared in more than one child class
     * @{ */
        QIRichTextLabel *m_pDescriptionLabel;
        QIRichTextLabel *m_pDynamicLabel;
        QIRichTextLabel *m_pFixedLabel;
        QIRichTextLabel *m_pSplitLabel;
    /** @} */
};

/* 2nd page of the New Virtual Hard Drive wizard (basic extension): */
class SHARED_LIBRARY_STUFF UIWizardNewVDPageVariant : public UIWizardPage, public UIWizardNewVDPageBaseVariant
{
    Q_OBJECT;
    Q_PROPERTY(qulonglong mediumVariant READ mediumVariant WRITE setMediumVariant);

public:

    UIWizardNewVDPageVariant();

private:

    void retranslateUi();
    void initializePage();
    bool isComplete() const;
};


#endif /* !FEQT_INCLUDED_SRC_wizards_newvd_UIWizardNewVDPageVariant_h */
